Index: test/org/opencms/workplace/explorer/TestCmsTree.java
===================================================================
RCS file: test/org/opencms/workplace/explorer/TestCmsTree.java
diff -N test/org/opencms/workplace/explorer/TestCmsTree.java
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ test/org/opencms/workplace/explorer/TestCmsTree.java	1 Jan 1970 00:00:00 -0000
@@ -0,0 +1,349 @@
+/*
+ * File   : $Source$
+ * Date   : $Date$
+ * Version: $Revision$
+ *
+ * This library is part of OpenCms -
+ * the Open Source Content Management System
+ *
+ * Copyright (C) 2002 - 2008 Alkacon Software (http://www.alkacon.com)
+ *
+ * This library is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2.1 of the License, or (at your option) any later version.
+ *
+ * This library is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+ * Lesser General Public License for more details.
+ *
+ * For further information about Alkacon Software, please see the
+ * company website: http://www.alkacon.com
+ *
+ * For further information about OpenCms, please see the
+ * project website: http://www.opencms.org
+ * 
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this library; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+ 
+package org.opencms.workplace.explorer;
+
+import org.opencms.file.CmsObject;
+import org.opencms.flex.CmsFlexController;
+import org.opencms.flex.CmsFlexDummyLoader;
+import org.opencms.flex.CmsFlexRequest;
+import org.opencms.flex.CmsFlexResponse;
+import org.opencms.flex.TestCmsFlexResponse.RecordingMock;
+import org.opencms.flex.TestCmsFlexResponse.RequestStub;
+import org.opencms.jsp.CmsJspActionElement;
+import org.opencms.main.CmsException;
+import org.opencms.main.CmsLog;
+import org.opencms.test.OpenCmsTestCase;
+import org.opencms.test.OpenCmsTestProperties;
+import org.opencms.util.CmsStringUtil;
+
+import java.lang.reflect.InvocationHandler;
+import java.lang.reflect.Proxy;
+import java.util.Collections;
+import java.util.Enumeration;
+import java.util.HashMap;
+import java.util.Map;
+
+import javax.servlet.http.HttpServletRequest;
+import javax.servlet.http.HttpServletResponse;
+import javax.servlet.http.HttpSession;
+
+import org.apache.commons.logging.Log;
+
+import junit.extensions.TestSetup;
+import junit.framework.Test;
+import junit.framework.TestSuite;
+
+/**
+ * UnitTest for {@link CmsTree}.
+ */
+public class TestCmsTree extends OpenCmsTestCase {
+
+    /** The log object for this class. */
+    private static final Log LOG = CmsLog.getLog(TestCmsTree.class);
+    
+    /**
+     * Default JUnit constructor.<p>
+     * 
+     * @param arg0 JUnit parameters
+     */
+    public TestCmsTree(String arg0) {
+
+        super(arg0);
+    }
+
+    /**
+     * Test suite for this test class.<p>
+     * 
+     * @return the test suite
+     */
+    public static Test suite() {
+
+        OpenCmsTestProperties.initialize(org.opencms.test.AllTests.TEST_PROPERTIES_PATH);
+
+        TestSuite suite = new TestSuite();
+        suite.setName(TestCmsTree.class.getName());
+
+        suite.addTest(new TestCmsTree("testGetTreeHappyPath"));
+        suite.addTest(new TestCmsTree("testGetTreeHappyPath2"));
+        suite.addTest(new TestCmsTree("testGetTreeHappyPath3"));
+        suite.addTest(new TestCmsTree("testGetTreeHappyPath4"));
+
+        TestSetup wrapper = new TestSetup(suite) {
+
+            @Override
+            protected void setUp() {
+
+                setupOpenCms("simpletest", "/sites/default/");
+            }
+
+            @Override
+            protected void tearDown() {
+
+                removeOpenCms();
+            }
+        };
+
+        return wrapper;
+    }
+    
+    /**
+     * Test HappyPath.
+     * 
+     * @throws CmsException if an error occurs 
+     */
+    public void testGetTreeHappyPath() throws CmsException {
+        // prepare params
+        Map<String, String> parameter = new HashMap<String, String>();
+        parameter.put("resource", "/");
+        // The Ids should be: jsp=4, image=3, xmlpage=6
+        parameter.put("resourcetypeIds", "3,4,6");
+        parameter.put("includefiles", "true");
+        
+        // get Treelines
+        String[] treeLines = getTreeLines(parameter);
+
+        // validate Result
+        assertEquals(14, treeLines.length);
+        assertTrue(treeLines[7].startsWith("parent.aC(\"index.html\""));
+        assertEquals("parent.setResourcetypeIds('3,4,6');", treeLines[12]);
+        
+    }
+    
+    /**
+     * Test HappyPath2. getTree of subFolder.
+     * 
+     * @throws CmsException if an error occurs 
+     */
+    public void testGetTreeHappyPath2() throws CmsException {
+        // prepare params
+        Map<String, String> parameter = new HashMap<String, String>();
+        parameter.put("resource", "/folder1/");
+        // The Ids should be: jsp=4, image=3, xmlpage=6
+        parameter.put("resourcetypeIds", "3,4,6");
+        parameter.put("includefiles", "true");
+        
+        // get Treelines
+        String[] treeLines = getTreeLines(parameter);
+
+        // validate Result
+        assertEquals(16, treeLines.length);
+        assertTrue(treeLines[4].startsWith("parent.aC(\"image2.gif\""));
+        assertEquals("parent.setResourcetypeIds('3,4,6');", treeLines[14]);
+        
+    }
+    
+    /**
+     * Test HappyPath3. getTree of subFolder without xmlpages.
+     * 
+     * @throws CmsException if an error occurs 
+     */
+    public void testGetTreeHappyPath3() throws CmsException {
+        // prepare params
+        Map<String, String> parameter = new HashMap<String, String>();
+        parameter.put("resource", "/folder1/");
+        // The Ids should be: jsp=4, image=3, xmlpage=6
+        parameter.put("resourcetypeIds", "3,4");
+        parameter.put("includefiles", "true");
+        
+        // get Treelines
+        String[] treeLines = getTreeLines(parameter);
+
+        // validate Result
+        assertEquals(11, treeLines.length);
+        assertTrue(treeLines[4].startsWith("parent.aC(\"image2.gif\""));
+        assertEquals("parent.setResourcetypeIds('3,4');", treeLines[9]);
+        
+    }
+    
+    /**
+     * Test HappyPath4 getTree without resourcetypeIds.
+     * 
+     * @throws CmsException if an error occurs 
+     */
+    public void testGetTreeHappyPath4() throws CmsException {
+        // prepare params
+        Map<String, String> parameter = new HashMap<String, String>();
+        parameter.put("resource", "/");
+        parameter.put("includefiles", "true");
+        
+        // get Treelines
+        String[] treeLines = getTreeLines(parameter);
+
+        // validate Result
+        assertEquals(13, treeLines.length);
+        assertTrue(treeLines[7].startsWith("parent.aC(\"index.html\""));
+    }
+
+    private String[] getTreeLines(Map<String, String> parameter) throws CmsException {
+
+        CmsJspActionElement cms = createCmsJspActionElement("index.html", parameter);
+        CmsTree cmsTree = new CmsTree(cms);
+        LOG.info("allParamsAsRequest: " + cmsTree.allParamsAsRequest());
+        LOG.info("getResourcetypeIds: " + cmsTree.getResourcetypeIds());
+        LOG.info("initTree: " + cmsTree.initTree());
+        LOG.info("getTreeType: " + cmsTree.getTreeType());
+        LOG.info("getTree: " + cmsTree.getTree());
+        String[] treeLines = CmsStringUtil.splitAsArray(cmsTree.getTree(), "\n");
+        return treeLines;
+    }
+
+    private CmsJspActionElement createCmsJspActionElement(String xmlFilePath, Map<String, String> parameter)
+    throws CmsException {
+
+        HttpServletRequest request = createMockRequest(parameter);
+        
+        RecordingMock resMock = new RecordingMock();
+        HttpServletResponse response = createMockResponse(resMock);
+        
+        initCmsFlexController(getCmsObject(), xmlFilePath, request, response);
+        
+        CmsJspActionElement cms = new CmsJspActionElement(null, request, response);
+        return cms;
+    }
+
+    private void initCmsFlexController(CmsObject cms, String xmlFilePath, HttpServletRequest request,
+            HttpServletResponse response) throws CmsException {
+        CmsFlexController controller = new CmsFlexController(
+            cms,
+            cms.readFile(xmlFilePath),
+            CmsFlexDummyLoader.getFlexCache(),
+            request,
+            response,
+            false,
+            false);
+        CmsFlexRequest cmsFlexRequest = new CmsFlexRequest(request, controller);
+        CmsFlexResponse cmsFlexResponse = new CmsFlexResponse(response, controller, false, false);
+        
+        controller.push(cmsFlexRequest, cmsFlexResponse);
+        CmsFlexController.setController(request, controller);
+    }
+    
+    /** 
+     * Convenience method to create a mock {@link HttpServletRequest} backed by the given invocation handler.<p>
+     * 
+     * @param recorder the mock recorder
+     *  
+     * @return the new created request
+     */
+    private static HttpServletRequest createMockRequest(Map<String, String> parameter) {
+        
+        RecordingMock sessionMock = new RecordingMock(new RequestStub());
+        final HttpSession session = (HttpSession)createProxy(HttpSession.class, sessionMock);
+        
+        RecordingMock reqMock = new RecordingMock(new RequestExtendedStub(session, parameter));
+        
+        HttpServletRequest request = (HttpServletRequest)createProxy(HttpServletRequest.class, reqMock);
+
+        
+        return request;
+    }
+
+    /** 
+     * Convenience method to create a mock {@link HttpServletResponse} backed by the given invocation handler.<p>
+     * 
+     * @param recorder the mock recorder
+     *  
+     * @return the new created response
+     */
+    private static HttpServletResponse createMockResponse(RecordingMock recorder) {
+
+        return (HttpServletResponse)createProxy(HttpServletResponse.class, recorder);
+    }
+
+    private static Object createProxy(Class<?> interfaceClass, InvocationHandler handler) {
+
+        return Proxy.newProxyInstance(
+            Thread.currentThread().getContextClassLoader(),
+            new Class[] {interfaceClass},
+            handler);
+    }
+
+    /** 
+     * A partial implementation of {@link HttpServletRequest} which allows for the setting and getting of request attributes.<p>
+     */
+    public static class RequestExtendedStub extends RequestStub {
+        
+        private HttpSession m_session;
+        private Map<String, String> m_parameter;
+
+        /**
+         * Constructor to generate a RequestStub with Session-Stub and Parameters handling.
+         * 
+         * @param session
+         * @param parameter
+         */
+        public RequestExtendedStub(HttpSession session, Map<String, String> parameter) {
+
+            super();
+            this.m_session = session;
+            this.m_parameter = parameter;
+        }
+
+        public HttpSession getSession() {
+            return m_session;
+        }
+
+
+        /**
+         * @see javax.servlet.ServletRequest#getParameter(java.lang.String)
+         */
+        public String getParameter(String key) {
+            return m_parameter.get(key);
+        }
+
+        /**
+         * @see javax.servlet.ServletRequest#getParameterMap()
+         */
+        public Map getParameterMap() {
+            return m_parameter;
+        }
+
+        /**
+         * @see javax.servlet.ServletRequest#getParameterNames()
+         */
+        public Enumeration getParameterNames() {
+
+            return Collections.enumeration(m_parameter.keySet());
+        }
+
+        /**
+         * @see javax.servlet.ServletRequest#getParameterValues(java.lang.String)
+         */
+        public String[] getParameterValues(String key) {
+            if (getParameter(key) == null) {
+                return new String[0];
+            } else {
+                return new String[]{getParameter(key)};
+            }
+        }
+    }
+}
\ No newline at end of file
Index: webapp/WEB-INF/cmsshell.bat
===================================================================
RCS file: /usr/local/cvs/opencms/webapp/WEB-INF/cmsshell.bat,v
retrieving revision 1.15
diff -u -r1.15 cmsshell.bat
--- webapp/WEB-INF/cmsshell.bat	29 Oct 2008 12:46:48 -0000	1.15
+++ webapp/WEB-INF/cmsshell.bat	24 Aug 2010 16:43:28 -0000
@@ -66,23 +66,15 @@
 :okTomcatHome
 
 rem Guess OPENCMS_LIB if not defined
-if not "%OPENCMS_LIB%" == "" goto gotLib
+if not "%OPENCMS_LIB%" == "" goto gotHome
 set OPENCMS_LIB=%OPENCMS_HOME%\lib
 :gotHome
 if exist "%OPENCMS_LIB%\opencms.jar" goto okLib
+if exist "%OPENCMS_LIB%\opencms-core.jar" goto okLib
 echo The OPENCMS_LIB environment variable is not defined correctly
 echo This environment variable is needed to run this program
 goto end
 :okLib
-rem Add all jars in lib dir to OPENCMS_CP variable (will include a initial semicolon ";")
-for %%i in ("%OPENCMS_LIB%\*.jar") do call "%OPENCMS_HOME%\cpappend.bat" %%i
-
-rem Check for Tomcat libs
-rem Add all jars in TOMCAT_HOME\common\lib dir to TOMCAT_LIB variable (will include a initial semicolon ";")
-for %%i in ("%TOMCAT_HOME%\common\lib\*.jar") do call "%OPENCMS_HOME%\tlappend.bat" %%i
-rem also support different tomcat folder structure
-for %%i in ("%TOMCAT_HOME%\lib\*.jar") do call "%OPENCMS_HOME%\tlappend.bat" %%i
-:okLib
 
 rem ----- Execute The Requested Command ---------------------------------------
 echo Using JAVA_HOME:       %JAVA_HOME%
@@ -95,18 +87,13 @@
 
 rem Get command line arguments and save them in 
 rem the CMD_LINE_ARGS environment variable
-set CMD_LINE_ARGS=
-:setArgs
-if ""%1""=="""" goto doneSetArgs
-set CMD_LINE_ARGS=%CMD_LINE_ARGS% %1
-shift
-goto setArgs
-:doneSetArgs
+set CMD_LINE_ARGS=%*
 
 @rem set opencms arguments
 set CMD_LINE_ARGS=%CMD_LINE_ARGS% -base="%CD%"
+echo %CMD_LINE_ARGS%
 
 rem execute OPENCMS
-%_RUNJAVA% %JAVA_OPTS% -classpath "%OPENCMS_HOME%\classes%CLASSPATH%%OPENCMS_CP%%TOMCAT_LIB%" %MAINCLASS% %CMD_LINE_ARGS%
+%_RUNJAVA% %JAVA_OPTS% -Djava.ext.dirs=%OPENCMS_LIB%;%TOMCAT_HOME%\common\lib;%TOMCAT_HOME%\lib -classpath "%OPENCMS_HOME%\classes%CLASSPATH%" %MAINCLASS% %CMD_LINE_ARGS%
 
 :end
\ No newline at end of file
